/* Sistemas Integrados TECNISA

Nome: 5037_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   22/06/2012 - Marcelo Alexsandro

Tabela VINCULOFISREGRA: Regra Fiscal.
Descrio: A trigger insere registros na tabela LOGREGRAFISCAL a partir de alteraes na tabela VINCULOFISREGRA
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_VINCULOFISREGRA' AND
                 TYPE   = 'TR' 	           AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_VINCULOFISREGRA
GO

CREATE TRIGGER LOG_FIS_VINCULOFISREGRA
ON VINCULOFISREGRA
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO    VARCHAR(40);
   DECLARE @V_DTOPER     DATETIME;

   DECLARE @V_ID_COMANDO VARCHAR(1);
   DECLARE @V_DESC       VARCHAR(350);
   DECLARE @V_ITPESQ     VARCHAR(40);
   DECLARE @V_NMOPERADOR VARCHAR(40);
   DECLARE @V_IDTIPOOPER VARCHAR(1);

   DECLARE @V_CDREGRAFISC_OLD     VARCHAR(10);
   DECLARE @V_NRVINCFISCREGRA_OLD VARCHAR(10);
   DECLARE @V_CDEMPRESA_OLD       VARCHAR(2);
   DECLARE @V_IDENTRSAIDOP_OLD    VARCHAR(1);
   DECLARE @V_CDTIPOOPER_OLD      VARCHAR(2);
   DECLARE @V_CDINSCESTA_OLD      VARCHAR(16);
   DECLARE @V_CDGRUPOFISC_OLD     VARCHAR(3);
   DECLARE @V_NRORDPRIORIDADE_OLD INTEGER;
   DECLARE @V_DTVALVINCFISC_OLD   DATETIME;

   DECLARE @V_CDREGRAFISC_NEW     VARCHAR(10);
   DECLARE @V_NRVINCFISCREGRA_NEW VARCHAR(10);
   DECLARE @V_CDEMPRESA_NEW       VARCHAR(2);
   DECLARE @V_IDENTRSAIDOP_NEW    VARCHAR(1);
   DECLARE @V_CDTIPOOPER_NEW      VARCHAR(2);
   DECLARE @V_CDINSCESTA_NEW      VARCHAR(16);
   DECLARE @V_CDGRUPOFISC_NEW     VARCHAR(3);
   DECLARE @V_NRORDPRIORIDADE_NEW INTEGER;
   DECLARE @V_DTVALVINCFISC_NEW   DATETIME;
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @V_NMOPERADOR;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
      DELETED.CDREGRAFISC,
      DELETED.NRVINCFISCREGRA,
      DELETED.CDEMPRESA,
      DELETED.IDENTRSAIDOP,
      DELETED.CDTIPOOPER,
      DELETED.CDINSCESTA,
      DELETED.CDGRUPOFISC,
      DELETED.NRORDPRIORIDADE,
      DELETED.DTVALVINCFISC,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
   FROM
     DELETED
   WHERE
     CDREGRAFISC+NRVINCFISCREGRA NOT IN (SELECT CDREGRAFISC+NRVINCFISCREGRA FROM INSERTED)

   UNION ALL

   SELECT
     'U' IDCOMANDO,
      DELETED.CDREGRAFISC,
      DELETED.NRVINCFISCREGRA,
      DELETED.CDEMPRESA,
      DELETED.IDENTRSAIDOP,
      DELETED.CDTIPOOPER,
      DELETED.CDINSCESTA,
      DELETED.CDGRUPOFISC,
      DELETED.NRORDPRIORIDADE,
      DELETED.DTVALVINCFISC,
      INSERTED.CDREGRAFISC,
      INSERTED.NRVINCFISCREGRA,
      INSERTED.CDEMPRESA,
      INSERTED.IDENTRSAIDOP,
      INSERTED.CDTIPOOPER,
      INSERTED.CDINSCESTA,
      INSERTED.CDGRUPOFISC,
      INSERTED.NRORDPRIORIDADE,
      INSERTED.DTVALVINCFISC
   FROM
      INSERTED,
      DELETED
   WHERE INSERTED.CDREGRAFISC = DELETED.CDREGRAFISC
     AND INSERTED.NRVINCFISCREGRA = DELETED.NRVINCFISCREGRA

   UNION ALL

   SELECT
     'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      INSERTED.CDREGRAFISC,
      INSERTED.NRVINCFISCREGRA,
      INSERTED.CDEMPRESA,
      INSERTED.IDENTRSAIDOP,
      INSERTED.CDTIPOOPER,
      INSERTED.CDINSCESTA,
      INSERTED.CDGRUPOFISC,
      INSERTED.NRORDPRIORIDADE,
      INSERTED.DTVALVINCFISC
   FROM INSERTED
   WHERE CDREGRAFISC+NRVINCFISCREGRA NOT IN (SELECT CDREGRAFISC+NRVINCFISCREGRA FROM DELETED);
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDREGRAFISC_OLD,
                                 @V_NRVINCFISCREGRA_OLD,
                                 @V_CDEMPRESA_OLD,
                                 @V_IDENTRSAIDOP_OLD,
                                 @V_CDTIPOOPER_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_CDGRUPOFISC_OLD,
                                 @V_NRORDPRIORIDADE_OLD,
                                 @V_DTVALVINCFISC_OLD,
                                 @V_CDREGRAFISC_NEW,
                                 @V_NRVINCFISCREGRA_NEW,
                                 @V_CDEMPRESA_NEW,
                                 @V_IDENTRSAIDOP_NEW,
                                 @V_CDTIPOOPER_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_CDGRUPOFISC_NEW,
                                 @V_NRORDPRIORIDADE_NEW,
                                 @V_DTVALVINCFISC_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'U' BEGIN
         SET @V_DESC = 'Empresa = '            + @V_CDEMPRESA_NEW       + ' ' +
                        'Tipo Operacao = '      + ISNULL(@V_IDENTRSAIDOP_NEW, '')    + ' ' +
                        'Operacao = '           + ISNULL(@V_CDTIPOOPER_NEW, '')      + ' ' +
                        'Inscricao Estadual = ' + ISNULL(@V_CDINSCESTA_NEW, '')      + ' ' +
                        'Grupo Fiscal = '       + ISNULL(@V_CDGRUPOFISC_NEW, '')     + ' ' +
                        'Prioridade = '         + CONVERT(VARCHAR, @V_NRORDPRIORIDADE_NEW) + ' ' +
                        'Validade Final = '     + ISNULL(CONVERT(VARCHAR, @V_DTVALVINCFISC_NEW, 103), '');
         SET @V_ITPESQ = @V_CDREGRAFISC_NEW+CONVERT(VARCHAR, @V_NRVINCFISCREGRA_NEW);
         SET @V_IDTIPOOPER = '2';
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'I' BEGIN
            SET @V_DESC = 'Empresa = '            + @V_CDEMPRESA_NEW       + ' ' +
                  'Tipo Operacao = '      + ISNULL(@V_IDENTRSAIDOP_NEW, '')    + ' ' +
                  'Operacao = '           + ISNULL(@V_CDTIPOOPER_NEW, '')      + ' ' +
                  'Inscricao Estadual = ' + ISNULL(@V_CDINSCESTA_NEW, '')      + ' ' +
                  'Grupo Fiscal = '       + ISNULL(@V_CDGRUPOFISC_NEW, '')     + ' ' +
                  'Prioridade = '         + CONVERT(VARCHAR, @V_NRORDPRIORIDADE_NEW) + ' ' +
                  'Validade Final = '     + ISNULL(CONVERT(VARCHAR, @V_DTVALVINCFISC_NEW, 103), '');
            SET @V_ITPESQ = @V_CDREGRAFISC_NEW+CONVERT(VARCHAR, @V_NRVINCFISCREGRA_NEW);
            SET @V_IDTIPOOPER = '1';
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'D' BEGIN
               SET @V_DESC = 'Empresa = '            + @V_CDEMPRESA_OLD       + ' ' +
                              'Tipo Operacao = '      + ISNULL(@V_IDENTRSAIDOP_OLD, '')    + ' ' +
                              'Operacao = '           + ISNULL(@V_CDTIPOOPER_OLD, '')      + ' ' +
                              'Inscricao Estadual = ' + ISNULL(@V_CDINSCESTA_OLD, '')      + ' ' +
                              'Grupo Fiscal = '       + ISNULL(@V_CDGRUPOFISC_OLD, '')     + ' ' +
                              'Prioridade = '         + CONVERT(VARCHAR, @V_NRORDPRIORIDADE_OLD) + ' ' +
                              'Validade Final = '     + ISNULL(CONVERT(VARCHAR, @V_DTVALVINCFISC_OLD, 103), '');
               SET @V_ITPESQ = @V_CDREGRAFISC_OLD+CONVERT(VARCHAR, @V_NRVINCFISCREGRA_OLD);
               SET @V_IDTIPOOPER = '3';
            END;
         END;
      END;
      INSERT INTO LOGREGRAFISCAL
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM)
       VALUES
         ('VINCULOFISREGRA',
          GETDATE(),
          ISNULL(@V_NMOPERADOR,' '),
          @V_IDTIPOOPER,
          @V_DESC,
          @V_ITPESQ);
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDREGRAFISC_OLD,
                                    @V_NRVINCFISCREGRA_OLD,
                                    @V_CDEMPRESA_OLD,
                                    @V_IDENTRSAIDOP_OLD,
                                    @V_CDTIPOOPER_OLD,
                                    @V_CDINSCESTA_OLD,
                                    @V_CDGRUPOFISC_OLD,
                                    @V_NRORDPRIORIDADE_OLD,
                                    @V_DTVALVINCFISC_OLD,
                                    @V_CDREGRAFISC_NEW,
                                    @V_NRVINCFISCREGRA_NEW,
                                    @V_CDEMPRESA_NEW,
                                    @V_IDENTRSAIDOP_NEW,
                                    @V_CDTIPOOPER_NEW,
                                    @V_CDINSCESTA_NEW,
                                    @V_CDGRUPOFISC_NEW,
                                    @V_NRORDPRIORIDADE_NEW,
                                    @V_DTVALVINCFISC_NEW;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_VINCULOFISREGRA','5.30.xxx';
GO
